/**
  All content copyright (c) 2003-2007 Terracotta, Inc.,
  except as may otherwise be noted in a separate copyright notice.
  All rights reserved.

*/
package org.terracotta.sample;

import java.io.Serializable;

import org.apache.commons.lang.SerializationUtils;

public class Main 
{
   public static Main instance = new Main();
   public int count = 0;
   public Linked head;
   
   private static class Linked implements Serializable
   {
       private Linked next = null;
       
       public Linked insert(Linked next)
       {
           return (this.next = next);
       }
       
       public String print()
       {
           Linked current = this;
           
           StringBuffer buffer = new StringBuffer();
           
           while (current != null) {
               if (buffer.length() > 0) {
                   buffer.append(" : ");
               }
               buffer.append(this);
               current = current.next;
           }
           return buffer.toString();
       }
   }
   
   private void read()
   {
       Linked clone = (Linked) SerializationUtils.clone(head);
       System.out.println(head.print());
       System.out.println(clone.print());
   }
   
   private void write()
   {
       head = new Linked();
       Linked current = head;
       
       for (int i = 0; i < 5; i++) {
           current = current.insert(new Linked());
       }       
   }
   
   public void run()
   {
       synchronized (this) {
           if (count == 0) {
               write();
               count++;
           } else {
               read();
           }
       }
   }
   
   public static void main(String[] args) {
      instance.run();
   }
}